// Java-Applet zur Euro0-Umrechnung; ohne Plugin


import java.awt.*;
import java.awt.event.*;
import java.text.*;
import javax.swing.*;

public class Euro extends JApplet implements ActionListener {
	// Zwei Texteingabefelder
	JTextField textfield_dm;      
	JTextField textfield_euro;
	// Schaltknopf
	JButton button;               
	// Umrechnungsfaktor / Euro
	final double factor = 1.95583;
	
  // Start-Methode:
	
  public void start () {
	// Fenster
  	Container cp = getContentPane();
  	// Verzicht auf Layoutmanager, d.h. man muss sich selbst um die Koordinaten / 
  	// Dimensionen der Komponenten kmmern; s.U.
  	cp.setLayout(null);
  	// Hintergrundfarbe des Fensters
  	cp.setBackground(Color.cyan);
  	
  	// Drei GUI-Objekte erzeugen
  	textfield_dm = new JTextField();
	textfield_euro = new JTextField();
	button = new JButton("DM in Euro");
	
	// Positionen und Mae der GUI-Objekte
	textfield_dm.setBounds(10,10,200,20);
	textfield_euro.setBounds(10,80,200,20);
	button.setBounds(300,40,100,40);
	
	// Die drei GUI-Objekte dem Fenster zufgen
	add(textfield_dm);
	add(textfield_euro);
	add(button);
	
	button.addActionListener(this);
	}
	
  // Reaktion auf Schaltknopf:
  // Diese Methode wird vom Interface ActionListener erwartet 
	
  public void actionPerformed (ActionEvent ae) {
	double dm = 0;
	// falls fehlerfreie Eingabe
	int fehlerindex = 0;
	try { 
	  // Den DM-Wert aus dem Fenster ziehen
	  dm = Double.parseDouble(textfield_dm.getText());
	  } 
	catch (NumberFormatException e) {
		dm = -1;
		textfield_euro.setText("Fehler in der Eingabe; keine Zahl");
		// deshalb:
		fehlerindex = 1;
	  }
	if (dm >= 0) {
	  // in Euro0 umrechnen
	  double euro = dm2euro(dm);
	  // Fr die Stringvariable Ausgabe formatieren
	  NumberFormat nf = NumberFormat.getInstance();
	  nf.setMaximumFractionDigits(2);
	  String ausgabe = nf.format(euro)+" ";
	  textfield_euro.setText(ausgabe);
	  } 
	else {
		
		// Kein Eingabefehler; aber es wurde eine negative Zahl ausgegeben
		if (fehlerindex != 1)
			textfield_euro.setText("Nur positive Betrge eingeben");
	     
	   }
	
	}
	
  // Die Methode fr die eigentliche Umrechnung:
  
  public double dm2euro (double dm) {
	return dm / factor;
	}
	
  }



