// Java-Applet zur Euro-Umrechnung; ohne Plugin
// Mit Labels und Bildern


import java.awt.*;
import java.awt.event.*;
import java.text.*;
import javax.swing.*;

public class EuroL extends JApplet implements ActionListener {
	// Zwei Texteingabefelder
	JTextField textfield_dm, textfield_euro; 
	// Vier Label
	JLabel label_dm,label_euro,label_button,label_bild;
	// Schaltknopf
	JButton button; 
	
	// Umrechnungsfaktor / Euro0
	final double factor = 1.95583;
	
  // Start-Methode:
	
  public void start () {
	// Fenster
  	Container cp = getContentPane();
  	// Verzicht auf Layoutmanager, d.h. man muss sich selbst um die Koordinaten / 
  	// Dimensionen der Komponenten kmmern; s.U.
  	cp.setLayout(null);
  	// Hintergrundfarbe des Fensters
  	cp.setBackground(Color.blue);
  	
  	// Bilder laden (!)
  	// Aus Sicherheitsgrnden drfen Applets nicht auf das lokale Dateisystem zugreifen
  	// Deshalb ist ein URL-Zugriff erforderlich
  	// GetCodeBase() liefert die Web-Adresse zurck, auf der die Class-Datei des
  	// Applets liegt; dort mssen also auch die Dateien (Bilder) liegen...
  	Image bild  = getImage(getCodeBase(),"euro-stier.jpg");
    Image bild2 = getImage(getCodeBase(),"Europa.jpg");
  	
  	
  	// Fnf GUI-Objekte erzeugen (Textfelder, Labels und den Button)
  	textfield_dm = new JTextField();
	textfield_euro = new JTextField();
	label_dm = new JLabel("DM");
	label_euro = new JLabel("EURO");
	label_button = new JLabel("Zur Umrechnung Europa-Fahne drcken");
	label_bild = new JLabel(new ImageIcon(bild));
    button = new JButton("DM in Euro",new ImageIcon(bild2));
	
	// Schriftfarbe der Komponenten
	label_dm.setForeground(Color.red);
	label_euro.setForeground(Color.yellow);
	label_button.setForeground(Color.yellow);
	button.setForeground(Color.green);
	
	
	// Positionen und Mae der GUI-Objekte
	label_dm.setBounds(10,10,40,10);
	textfield_dm.setBounds(10,30,200,20);
	label_euro.setBounds(10, 80, 40, 10);
	textfield_euro.setBounds(10,100,200,20);
	label_button.setBounds(300,10,400,18); 
	button.setBounds(300,35,300,90);
	label_bild.setBounds(120,150,250,250);
	
	// Alle GUI-Objekte dem Fenster zufgen
	add(textfield_dm);
	add(textfield_euro);
	add(label_dm);
	add(label_euro);
	add(label_bild);
	add(label_button);
	add(button);
	
	button.addActionListener(this);
	}
	
  // Reaktion auf Schaltknopf:
  // Diese Methode wird vom Interface ActionListener erwartet 
	
  public void actionPerformed (ActionEvent ae) {
	double dm = 0;
	// falls fehlerfreie Eingabe
	int fehlerindex = 0;
	try { 
	  // Den DM-Wert aus dem Fenster ziehen
	  dm = Double.parseDouble(textfield_dm.getText());
	  } 
	catch (NumberFormatException e) {
		dm = -1;
		textfield_euro.setText("Fehler in der Eingabe; keine Zahl");
		// deshalb:
		fehlerindex = 1;
	  }
	if (dm >= 0) {
	  // in Euro0 umrechnen
	  double euro = dm2euro(dm);
	  // Fr die Stringvariable Ausgabe formatieren
	  NumberFormat nf = NumberFormat.getInstance();
	  nf.setMaximumFractionDigits(2);
	  String ausgabe = nf.format(euro)+" ";
	  textfield_euro.setText(ausgabe);
	  } 
	else {
		
		// Kein Eingabefehler; aber es wurde eine negative Zahl ausgegeben
		if (fehlerindex != 1)
			textfield_euro.setText("Nur positive Betrge eingeben");
	     
	   }
	
	}
	
  // Die Methode fr die eigentliche Umrechnung:
  
  public double dm2euro (double dm) {
	return dm / factor;
	}
	
  }



