// Java-Applet NWiege0
// Newtons Wiege (Demonstration von Impuls- und Energieerhaltungssatz)
// Kompilierung mit J2SDK 1.6.0
// Walter Fendt
// 03.11.1997 - 24.03.2009

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class NWiege3 extends JApplet implements Runnable {

//-----------------------------------------------------------------------------	
// Konstanten
//-----------------------------------------------------------------------------
  
  final int N = 5;                          // Zahl der Pendel
  final int R = 20;                         // Radius Pendelkrper (Pixel)
  final int R2 = 2*R;                       // Durchmesser Pendelkrper (Pixel)
  final int L = 200;                        // Pendellnge (Pixel)
  final double A = 0.4;                     // Amplitude (Bogenma)
  final double T = 2;                       // Schwingungsdauer (s)
  final double OMEGA = 2*Math.PI/T;         // Kreisfrequenz (1/s)  
  final Color FZF = Color.yellow;           // Hintergrundfarbe Zeichenflche
  final Color FSF = Color.green;            // Hintergrundfarbe Schaltflche0
  final Font SANSSERIF                      // Logischer Font
    = new Font("SansSerif",Font.BOLD,12);
   
//----------------------------------------------------------------------------- 
// Attribute
//-----------------------------------------------------------------------------
  
  Container cp;                             // Content Pane
  int breite, hhe, hhe0;                  // Abmessungen (Pixel)
  Zeichenflche zf;                         // Zeichenflche
  Schaltflche0 sf;                          // Schaltflche0
  JComboBox ch;                             // Auswahlfeld

  int ax, ay;                               // Aufhngung des linken Pendels
  double phi;                               // Phase (Bogenma)
  Thread thr;                               // Prozess fr Animation
  double t;                                 // Zeit (s)
  
//-----------------------------------------------------------------------------
// Weitere Methoden
//-----------------------------------------------------------------------------

  // Start-Methode:

  public void start () {
  	cp = getContentPane();                  // Container fr Komponenten
  	cp.setLayout(null);                     // Hartes Layout (Pixelangaben)
  	Dimension dim = getSize();              // Abmessungen (aus HTML-Datei)
  	breite = dim.width;                     // Breite (Pixel) 
  	hhe = dim.height;                      // Gesamthhe (Pixel)
  	hhe0 = 280;                            // Hhe der Zeichenflche (Pixel)
  	ay = 40;                                // Aufhngung, unterer Rand 
    ax = breite/2-(N-1)*R;                  // Aufhngung (linkes Pendel)
    zf = new Zeichenflche();               // Zeichenflche (innere Klasse) 
    zf.setBackground(FZF);                  // Hintergrundfarbe Zeichenflche
    zf.setBounds(0,0,breite,hhe0);         // Position/Abmessungen Zeichenflche
    cp.add(zf);                             // Zeichenflche hinzufgen
    sf = new Schaltflche0(FSF,SANSSERIF);   // Schaltflche0
    sf.setBounds(0,hhe0,breite,hhe-hhe0);// Position/Abmessungen Schaltflche0
    String text                             // Zeichenkette fr Label 
      = "Zahl der ausgelenkten Kugeln:";
    sf.hinzufgen(new JLabel(text),         // Label hinzufgen
      FSF,0,0,1,10,10,10,0);
    ch = new JComboBox();                   // Auswahlfeld
    for (int i=1; i<=N; i++)                // Felder fr die Zahl ...
      ch.addItem("  "+i+"  ");              // ... der ausgelenkten Kugeln
    ch.setSelectedIndex(1);                 // Voreinstellung: Zwei Kugeln ausgelenkt
    sf.hinzufgen(ch,                       // Auswahlfeld hinzufgen
      Color.white,1,0,1,10,10,10,10);
    text = "  W. Fendt 1997";              // Zeichenkette fr Label
    sf.hinzufgen(new JLabel(text),         // Label hinzufgen
      FSF,2,0,1,10,30,10,10);
    cp.add(sf);                             // Schaltflche0 hinzufgen 
    thr = new Thread(this);                 // Prozess fr Animation 
    thr.start();                            // Prozess starten
    }

  // Stopp-Methode:

  public void stop () {
  	thr = null;                             // Prozess fr Garbage Collection freigeben 
  	cp.removeAll();                         // Komponenten entfernen
    }

  // Methode fr Animation (Endlosschleife):

  public void run () {
    long t0, t1;
    t0 = System.currentTimeMillis();        // Zeit in ms
    sf.repaint();                           // Schaltflche0 neu zeichnen
    while (thr == Thread.currentThread()) { // Solange Prozess thr aktiv ...
      zf.repaint();                         // ... Zeichenflche neu zeichnen
      try {Thread.sleep(50);}               // ... 50 ms Unterbrechung 
      catch (InterruptedException ie) {}
      t1 = System.currentTimeMillis();      // ... Zeit in ms
      t += (t1-t0)/1000.0;                  // ... Zeit seit der letzten Ablesung in s
      t0 = t1;                              // ... Zeit in ms
      }
    }

  // Einzelnes Pendel:
  // g ... Grafik-Kontext
  // i ... Nummer (0 bis N-1)

  void pendel (Graphics g, int i) {
    while (t >= T) t -= T;                  // Bedingung 0 <= t < T erzwingen
    phi = A*Math.cos(OMEGA*t);              // Phase (Bogenma) 
    int k = ch.getSelectedIndex()+1;        // Zahl der ausgelenkten Kugeln 
    int px, py;                             // Mittelpunktskoordinaten der Kugel 
    boolean links = (t < T/4 || t >= 3*T/4);// Auslenkung nach links    
    if ((links && i < k)                    // Kugel nach links ausgelenkt  
    || (!links && i >= N-k)) {              // Kugel nach rechts ausgelenkt
      px = (int)Math.round(ax+i*R2-L*Math.sin(phi));  // x-Koordinate Kugelmittelpunkt
      py = (int)Math.round(ay+L*Math.cos(phi));       // y-Koordinate Kugelmittelpunkt
      }
    else {px = ax+i*R2; py = ay+L;}         // Kugel in Ruhe
    g.setColor(Color.black);                // Faden 
    g.drawLine(ax+i*R2,ay,px,py); 
    g.setColor(Color.blue);                 // Pendelkrper (Kreisflche) 
    g.fillOval(px-R,py-R,R2,R2); 
    g.setColor(Color.black);                // Pendelkrper (Kreisrand) 
    g.drawOval(px-R,py-R,R2,R2);
    }
    
  // --------------------------------------------------------------------------
  
  // Innere Klasse Zeichenflche:
  
  class Zeichenflche extends JPanel {
  	
  	// Grafik-Ausgabe:
  	// g ... Grafik-Kontext
  	
  	public void paint (Graphics g) {
      super.paint(g);                       // Hintergrund zeichnen
      g.setColor(Color.black);              // Aufhngung zeichnen 
      g.fillRect(breite/2-(N+1)*R,ay-4,(N+1)*R2,4); 
      for (int i=0; i<N; i++) pendel(g,i);  // Einzelne Pendel zeichnen
      }
      
    } // Ende Zeichenflche

  } // Ende NWiege0






