// Java-Klasse Schaltflche
// Kompilierung mit JDK 1.6.0
// Walter Fendt
// 01.12.2001 - 24.03.2009

import java.awt.*;
import javax.swing.*;

public class Schaltflche extends JPanel {

//-----------------------------------------------------------------------------	
// Attribute
//-----------------------------------------------------------------------------
	
  Font zeichensatz;                    // Zeichensatz
	
//-----------------------------------------------------------------------------
// Konstruktoren
//-----------------------------------------------------------------------------

  // Konstruktor:
  
  public Schaltflche (Color hintergrundfarbe, Font zeichensatz) {
  	setBackground(hintergrundfarbe);
  	this.zeichensatz = zeichensatz;
  	setLayout(new GridBagLayout());
    }

//-----------------------------------------------------------------------------    
// Weitere Methoden
//-----------------------------------------------------------------------------
	
  // Hinzufgen einer Komponente:

  void hinzufgen (JComponent komponente, Color hintergrundfarbe, 
  Color vordergrundfarbe, Font zeichensatz, 
  int spalte, int zeile, int breite, 
  int abstandOben, int abstandLinks, int abstandUnten, int abstandRechts) {
    GridBagConstraints c = new GridBagConstraints();
    c.gridx = spalte; c.gridy = zeile; 
    c.gridwidth = breite; c.gridheight = 1;
    c.fill = GridBagConstraints.HORIZONTAL; 
    c.anchor = GridBagConstraints.CENTER;
    c.weightx = breite; c.weighty = 1;
    c.insets = new Insets(abstandOben,abstandLinks,abstandUnten,abstandRechts);
    ((GridBagLayout)getLayout()).setConstraints(komponente,c);
    komponente.setFont(zeichensatz); 
    komponente.setBackground(hintergrundfarbe);
    komponente.setForeground(vordergrundfarbe);
    add(komponente);
    }
    
  // Hinzufgen einer Komponente, vereinfachte Variante:
  // Vordergrundfarbe schwarz, voreingestellter Zeichensatz
    
  void hinzufgen (JComponent komponente, Color hintergrundfarbe, 
  int spalte, int zeile, int breite,
  int abstandOben, int abstandLinks, int abstandUnten, int abstandRechts) {
  	hinzufgen(komponente,hintergrundfarbe,Color.black,zeichensatz,
  	spalte,zeile,breite,abstandOben,abstandLinks,abstandUnten,abstandRechts);
    }
    
  } // Ende Schaltflche
