package test;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.text.NumberFormat;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.event.CaretEvent;
import javax.swing.event.CaretListener;



public class AppWindow extends JFrame {
	//Vier Klassenvariable deklarieren
	JTextField textfield_dm;      // Zwei Texteingabefelder
	JTextField textfield_euro;
	JButton button, button_exit;  // Zwei Knpfe
    
	// Konstruktor
	public AppWindow() {
		this.getContentPane().setLayout(null);  // Ohne Layoutmanager
		this.initWindow();                      // Positionen genau angeben
	}

	public void initWindow() {
		// Vier GUI-Objekte erzeugen
		textfield_dm = new JTextField();
		textfield_euro = new JTextField();
		button = new JButton("DM in Euro");
		button_exit = new JButton("Ende");

		// Positionen und Mae der GUI-Objekte
		textfield_dm.setBounds(5, 10, 200, 25);
		textfield_euro.setBounds(5, 80, 200, 25);
		button.setBounds(300, 40, 100, 30);
		button_exit.setBounds(300, 110, 100, 30);
		
		// Bei beiden Knpfen auf das Ereignis warten und reagieren
		button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				buttonBerechneClicked();
			}

		});
		button_exit.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				System.exit(0);

			}

		});

		// Die vier GUI-Objekte dem Fenster zufgen
		this.getContentPane().add(textfield_dm);
		this.getContentPane().add(textfield_euro);
		this.getContentPane().add(button);
		this.getContentPane().add(button_exit);
		this.pack();

	}
    // Die Methode fr die Aktion, wenn der Knopf gedrckt wird
	public void buttonBerechneClicked() {
		double dm = 0;
		try {
			// Den DM-Wert aus dem Fenster ziehen
			dm = Double.parseDouble(textfield_dm.getText());
		} catch (NumberFormatException e) {
			dm = -1;
		}
		if (dm >= 0) {
			// in Euro umrechnen
			double euro = dm2euro(dm);
			// Fr die Stringvariable  ausgabe formatieren
			NumberFormat nf=NumberFormat.getInstance();
			nf.setMaximumFractionDigits(2);
			String ausgabe =  nf.format(euro)+"";
			textfield_euro.setText(ausgabe);

		} else
			textfield_euro.setText("Fehler in der Eingabe");

	}
    // Die Methode fr die eigentliche Umrechnung
	public double dm2euro(double dm) {
		double euro = dm / 1.95583;
		return euro;
	}

}
